/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PARAMFILIAL                                              */
/* Tabela : PARAMFILIAL                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 29/09/2009 - Fleas		                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS (SELECT * FROM sysobjects O, sysusers U
				WHERE
					o.name = 'DTULTATUPAFI_PARAMFILIAL' and
					type  =  'TR'			   and
					u.uid =  o.uid			   and
					u.name = USER)
	DROP TRIGGER DTULTATUPAFI_PARAMFILIAL
GO

CREATE TRIGGER DTULTATUPAFI_PARAMFILIAL
ON PARAMFILIAL
FOR INSERT, UPDATE, DELETE
AS
DECLARE @V_IDUT VARCHAR(1);
BEGIN

	IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
		INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
						(SELECT 'PARAM_FILIAL', CDFILIAL, 'CDFILIAL=' + CDFILIAL + ';',
								CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED);
	END
	ELSE BEGIN
		UPDATE PARAMFILIAL
			SET DTULTATUPAFI = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
		  FROM INSERTED, PARAMFILIAL P
		 WHERE P.CDFILIAL = INSERTED.CDFILIAL;

		SELECT @V_IDUT = MAX(P.IDUTMODPRODFIL)
		  FROM PARAMFILIAL P, INSERTED
		 WHERE P.CDFILIAL = INSERTED.CDFILIAL;
      IF @V_IDUT IS NOT NULL BEGIN
         UPDATE PARAVEND
            SET DTULTATUPAVN  = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)),
                IDUTILMODPROD = @V_IDUT
           FROM INSERTED
          WHERE (ISNULL(PARAVEND.CDFILIAL, 0)  = ISNULL(INSERTED.CDFILIAL, 0));
      END;
	END;
END;
GO

UPDATE PARAMFILIAL SET DTULTATUPAFI = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUPAFI IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUPAFI' and
            type = 'D')
   ALTER TABLE PARAMFILIAL DROP CONSTRAINT DEFAULT_DTULTATUPAFI
GO

ALTER TABLE PARAMFILIAL ADD CONSTRAINT DEFAULT_DTULTATUPAFI
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUPAFI
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PARAMFILIAL','5.07.026';
GO